Public Class Form1
  Inherits System.Windows.Forms.Form
#Region "Local Variables"

  Private style As Syncfusion.Windows.Forms.Grid.GridStyleInfo
  Private data As Syncfusion.Windows.Forms.Grid.GridData
  Private clickoncell As Boolean = False
  Private sc As New Specialized.StringCollection

#End Region
  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    Application.DoEvents()
    Windows.Forms.Cursor.Current = Cursors.WaitCursor

    ''''Conects data object to the grid
    Data = GC1.Data

    GC1.Model.RowHeights(0) = 45 'set height of header row 
    GC1.Model.ColWidths(0) = 180 'set width of header row 
    ''''set the clip board flags
    GC1.Model.CutPaste.ClipboardFlags += Syncfusion.Windows.Forms.Grid.GridDragDropFlags.NoAppendRows + Syncfusion.Windows.Forms.Grid.GridDragDropFlags.NoAppendCols - Syncfusion.Windows.Forms.Grid.GridDragDropFlags.Styles
    GC1.WantTabKey = False
    ''Syncfusion suggested code to support the new NullValve property, which fixes copy & paste of a null value (zero).
    GC1.BaseStylesMap("Standard").StyleInfo.CurrencyEdit.NullValue = 0


    Dim i, j As Integer

    sc.Add("NO")
    sc.Add("YES")

    GC1.BeginUpdate()

    For i = 1 To 98
      If Not data(i, 3) Is Nothing Then
        style = New Syncfusion.Windows.Forms.Grid.GridStyleInfo(data(i, 3))
      Else
        style = New Syncfusion.Windows.Forms.Grid.GridStyleInfo
      End If
      With style
        .CellType = "ComboBox"
        .ChoiceList = sc

        .DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Exclusive
        .ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide
        .HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center
        .CharacterCasing = CharacterCasing.Upper
        .CellValue = sc.Item("1") 'sc.Item(1)
        data(i, 3) = .Store
      End With
    Next



    GC1.EndUpdate()

  End Sub
  Private Sub gc1_CellClick(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs) Handles GC1.CellClick

    clickoncell = True

  End Sub

  Private Sub gc1_CurrentCellMoving(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCurrentCellMovingEventArgs) Handles GC1.CurrentCellMoving

    clickoncell = False

  End Sub

  Private Sub gc1_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs) Handles GC1.CurrentCellShowingDropDown

    If clickoncell Then
      e.Cancel = True
      clickoncell = False
    End If

  End Sub
  Private Sub GC1_PasteCellText(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridPasteCellTextEventArgs) Handles GC1.PasteCellText

    If CType(e.Style, Syncfusion.Windows.Forms.Grid.GridStyleInfo).ReadOnly Then
      e.Cancel = True
    End If

    e.Text = e.Text.ToUpper
    Try
      If e.ColIndex = 3 Then
        Dim yn As String = e.Text.ToUpper
        Select Case yn
          Case "YES", "NO"
          Case Else
            Throw New Exception("")
        End Select
      Else
        Dim i As Single = Single.Parse(e.Text)
        Select Case e.ColIndex
          Case 1
            If i > 10.0F Then Throw New Exception("")
          Case 2
            If i > 10 Then Throw New Exception("")
          Case Else
            Throw New Exception("")
        End Select
      End If
    Catch
      MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
        "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
        MessageBoxIcon.Warning)
      e.Abort = True
    End Try

  End Sub

  Private Sub GC1_ClipboardPaste(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs) Handles GC1.ClipboardPaste

    Dim blnHandled As Boolean
    GC1.BeginUpdate()
    blnHandled = ClipboardPaste(GC1)
    GC1.EndUpdate()
    GC1.Refresh()
    e.Handled = blnHandled

  End Sub

  Private Function ClipboardPaste(ByVal dg As Syncfusion.Windows.Forms.Grid.GridControl) As Boolean

    Try
      Cursor = Cursors.WaitCursor

      Dim intRow, intCol As Integer

      Dim objRange As Syncfusion.Windows.Forms.Grid.GridRangeInfo = dg.Selections.Ranges.ActiveRange
      objRange = objRange.ExpandRange(1, 1, dg.RowCount, dg.ColCount)

      ' Declares an IDataObject to hold the data returned from the clipboard.
      ' Retrieves the data from the clipboard.
      Dim iData As IDataObject = Clipboard.GetDataObject()
      Dim strText() As String

      'If there is more than one row, return false so that the paste can proceed.
      strText = Microsoft.VisualBasic.Split(CType(iData.GetData(DataFormats.Text), String), Microsoft.VisualBasic.vbNewLine)
      If strText.GetUpperBound(0) > 1 Then
        Return False
      End If

      'If there is more than one column, return
      strText = Microsoft.VisualBasic.Split(CType(iData.GetData(DataFormats.Text), String), Microsoft.VisualBasic.vbTab)
      If strText.GetUpperBound(0) > 0 Then
        Return False
      End If

      'If the paste is a single cell, return false so that the paste can proceed.
      If objRange.Top = objRange.Bottom And objRange.Left = objRange.Right Then
        'dg(dg.CurrentCell.RowIndex, dg.CurrentCell.ColIndex).Text = ""
        Return False
      End If

      Dim pasteValue As String = CType(iData.GetData(DataFormats.Text), String)
      pasteValue = pasteValue.Trim()

      'Loop through the selected rows and paste the value into each cell.
      For intRow = objRange.Top To objRange.Bottom
        Try
          Cursor = Cursors.WaitCursor
          'Paste into each cell for the row.
          For intCol = objRange.Left To objRange.Right
            'MessageBox.Show(intRow.ToString & " " & intCol.ToString)
            Try
              If intCol = 3 Then
                Dim yn As String = pasteValue.ToUpper
                Select Case yn
                  Case "YES", "NO"

                  Case Else
                    Throw New Exception("")
                End Select
              Else
                Dim i As Single = Single.Parse(pasteValue)
                Select Case intCol
                  Case 1, 2
                    If i > 10.0F Then Throw New Exception("")
                  Case Else
                    Throw New Exception("")
                End Select
              End If
            Catch
              MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
                "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
                MessageBoxIcon.Warning)
              Return True
            End Try

            ' Determines whether the data is in a format you can use.
            If iData.GetDataPresent(DataFormats.Text) Then
              'Put the clipboard value into the cell.
              dg(intRow, intCol).Text = pasteValue.ToUpper
            End If
          Next
        Catch ex As System.Exception
          MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
               "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
               MessageBoxIcon.Warning)
        Finally
          Cursor = Cursors.Default
        End Try
      Next
      Return True
    Catch ex As System.Exception
      MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
           "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
           MessageBoxIcon.Warning)
    Finally
      Cursor = Cursors.Default
    End Try

  End Function
End Class
